Fix jailed raw sockets not setting the correct source address by
calling in_pcbladdr instead of prison_get_ip4
--- sys/netinet/in_pcb.h.orig	2013-04-05 16:59:33.005670964 +0000
+++ sys/netinet/in_pcb.h	2013-04-05 17:00:24.725266747 +0000
@@ -490,6 +490,8 @@
 	    struct ucred *, int);
 int	in_pcbbind_setup(struct inpcb *, struct sockaddr *, in_addr_t *,
 	    u_short *, struct ucred *);
+int in_pcbladdr(struct inpcb *, struct in_addr *, struct in_addr *,
+    struct ucred *);
 int	in_pcbconnect(struct inpcb *, struct sockaddr *, struct ucred *);
 int	in_pcbconnect_setup(struct inpcb *, struct sockaddr *, in_addr_t *,
 	    u_short *, in_addr_t *, u_short *, struct inpcb **,
--- sys/netinet/in_pcb.c.orig	2013-04-05 16:59:28.252798648 +0000
+++ sys/netinet/in_pcb.c	2013-04-05 16:59:38.888509732 +0000
@@ -596,7 +596,7 @@
  * Do proper source address selection on an unbound socket in case
  * of connect. Take jails into account as well.
  */
-static int
+int
 in_pcbladdr(struct inpcb *inp, struct in_addr *faddr, struct in_addr *laddr,
     struct ucred *cred)
 {
--- sys/netinet/raw_ip.c.orig	2013-04-05 16:44:24.458314711 +0000
+++ sys/netinet/raw_ip.c	2013-04-05 17:10:54.902524046 +0000
@@ -442,16 +442,16 @@
 		ip->ip_p = inp->inp_ip_p;
 		ip->ip_len = m->m_pkthdr.len;
 		ip->ip_src = inp->inp_laddr;
+		ip->ip_dst.s_addr = dst;
 		if (jailed(inp->inp_cred)) {
 			/*
 			 * prison_local_ip4() would be good enough but would
 			 * let a source of INADDR_ANY pass, which we do not
-			 * want to see from jails. We do not go through the
-			 * pain of in_pcbladdr() for raw sockets.
+			 * want to see from jails.
 			 */
 			if (ip->ip_src.s_addr == INADDR_ANY)
-				error = prison_get_ip4(inp->inp_cred,
-				    &ip->ip_src);
+				error = in_pcbladdr(inp, &ip->ip_dst, &ip->ip_src,
+				    inp->inp_cred);
 			else
 				error = prison_local_ip4(inp->inp_cred,
 				    &ip->ip_src);
@@ -461,7 +461,6 @@
 				return (error);
 			}
 		}
-		ip->ip_dst.s_addr = dst;
 		ip->ip_ttl = inp->inp_ip_ttl;
 	} else {
 		if (m->m_pkthdr.len > IP_MAXPACKET) {
